using Edu.Common.Enum;
using Edu.Model.Entity.Course;
using Edu.Model.Entity.Sell;
using Edu.Model.ViewModel.Course;
using Edu.Model.ViewModel.Sell;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VT.FW.DB.Dapper;

namespace Edu.Repository.Sell
{
    /// <summary>
    /// 投稿提成期数仓储层
    /// </summary>
    public class RB_TeaCon_Commission_PeriodsRepository : BaseRepository<RB_TeaCon_Commission_Periods>
    {
        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_TeaCon_Commission_Periods_ViewModel> GetList(RB_TeaCon_Commission_Periods_ViewModel demodel)
        {
            string where = $@" 1=1";
            
            if (demodel.Group_Id > 0)
            {
                where += $@" and r.{nameof(RB_TeaCon_Commission_Periods_ViewModel.Group_Id)} ={demodel.Group_Id}";
            }
            if (!string.IsNullOrEmpty(demodel.Name))
            {
                where += $@" and r.{nameof(RB_TeaCon_Commission_Periods_ViewModel.Name)} like '%{demodel.Name}%'";
            }
            if (!string.IsNullOrEmpty(demodel.Periods))
            {
                where += $@" and r.{nameof(RB_TeaCon_Commission_Periods_ViewModel.Periods)} ='{demodel.Periods}'";
            }

            string sql = $@" select r.* from RB_TeaCon_Commission_Periods r where {where} order by r.Id desc";
            return Get<RB_TeaCon_Commission_Periods_ViewModel>(sql).ToList();
        }

        /// <summary>
        /// 获取分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="count"></param>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_TeaCon_Commission_Periods_ViewModel> GetPageList(int pageIndex,int pageSize,out long count, RB_TeaCon_Commission_Periods_ViewModel demodel)
        {
            string where = $@" 1=1";

            if (demodel.Group_Id > 0)
            {
                where += $@" and r.{nameof(RB_TeaCon_Commission_Periods_ViewModel.Group_Id)} ={demodel.Group_Id}";
            }
            if (!string.IsNullOrEmpty(demodel.Name))
            {
                where += $@" and r.{nameof(RB_TeaCon_Commission_Periods_ViewModel.Name)} like '%{demodel.Name}%'";
            }

            string sql = $@" select r.* from RB_TeaCon_Commission_Periods r where {where} order by r.Id desc";
            return GetPage<RB_TeaCon_Commission_Periods_ViewModel>(pageIndex, pageSize, out count, sql).ToList();
        }

    }
}
